unit SSPI;

{
Composants TClientSocketSSPI et TServerSocketSSPI (drivs des composants anctres de TClientSocket et TServerSocket),
sockets non bloquants. Ces composants ont t dvelopps en s'inspirant du code http://www.torry.net/authorsmore.php?id=7131
de Naberegnyh Sergey N. et orients objet.

La procdure d'authentification rejoint celle expose par Microsoft sur http://msdn.microsoft.com/en-us/library/aa379449%28v=vs.85%29
(utilisation des packages NTLM et Kerberos selon les cas).

TClientSocketSSPI
-----------------

Proprits :
 - Mode : SSPIAMCurrentUser pour utiliser les droits de l'utilisateur courant
       ou SSPIAMLogon pour utiliser les droits d'un autre utilisateur
 - Domain : pour dfinir le domaine de l'utilisateur (cas o Mode = SSPIAmLogin)
 - UserName : pour dfinir le login de l'utilisateur (cas o Mode = SSPIAmLogin)
 - Password : pour dfinir le mot de passe de l'utilisateur (cas o Mode = SSPIAmLogin)
 - IsAuthenticating : Indique si le processus d'authentification est en cours

Procdure :
 - Authenticate : pour procder  l'authentification.

Evnements :
 - OnAuthFailed : chec d'authentification
 - OnAuthSuccess : succs de l'authentification.


TClientSocketSSPI
-----------------

Proprit :
 - IsAuthenticating : Indique si un processus d'authentification est en cours
 - GuestEnabled : Indique si l'authentification anonyme est autorise
 
Evnements :
 - OnAuthenticating : survient quand un client tente une authentification (possibilit d'accepter ou refuser)
 - OnAuthFailed : chec d'authentification
 - OnAuthSuccess : succs de l'authentification.

 Test sous Delphi 7 & XE.

 Columbo pour phidels.com

 27/08/2012
}

interface

uses Windows, SysUtils, WinSock, Classes, Math, ScktComp;

const
  secur32 = 'secur32.dll';
  SECURITY_NATIVE_DREP  = $00000010;
  SECPKG_ATTR_SIZES            = 0;
  SECBUFFER_TOKEN              = 2; // Security token
  SECBUFFER_VERSION = 0;
  SECBUFFER_DATA               = 1; // Packet data
  SECBUFFER_PADDING            = 9; // non-data padding
  SECPKG_CRED_INBOUND  = $00000001;
  SECPKG_CRED_OUTBOUND = $00000002;
  ISC_REQ_INTEGRITY              = $00010000;
  SECPKG_ATTR_NEGOTIATION_INFO = 12;
  SEC_WINNT_AUTH_IDENTITY_ANSI    = $1;
  SEC_WINNT_AUTH_IDENTITY_UNICODE = $2;
  SEC_I_COMPLETE_NEEDED = HRESULT($00090313);
  SEC_I_COMPLETE_AND_CONTINUE = HRESULT($00090314);
  SEC_E_OK = HRESULT($00000000);
  CRED_MAX_DOMAIN_TARGET_NAME_LENGTH       = (256+1+80);
  CRED_MAX_USERNAME_LENGTH                 = (256+1+256);
  sPackageName: String = 'Negotiate';
  Addr_Buf_Len = SizeOf(TSockAddrIn) + 16;

type
  SEC_CHAR = CHAR;
  PSEC_CHAR = ^SEC_CHAR;
  PSecChar = ^TSecChar;
  TSecChar = SEC_CHAR;
  SECURITY_STATUS = longint;
  PSecHandle = ^SecHandle;
  _SecHandle = record
    dwLower: Longword;
    dwUpper: Longword;
  end;
  SecHandle = _SecHandle;
  TSecHandle = SecHandle;
  CredHandle = SecHandle;
  PCredHandle = ^CredHandle;
  TCredHandle = CredHandle;

  CtxtHandle = SecHandle;
  PCtxtHandle = ^CtxtHandle;

  PSecPkgContext_Sizes = ^SecPkgContext_Sizes;
  _SecPkgContext_Sizes = record
    cbMaxToken: Cardinal;
    cbMaxSignature: Cardinal;
    cbBlockSize: Cardinal;
    cbSecurityTrailer: Cardinal;
  end;
  SecPkgContext_Sizes = _SecPkgContext_Sizes;
  PTimeStamp = ^LARGE_INTEGER;
  TimeStamp = LARGE_INTEGER;
  TTimeStamp = TimeStamp;

  PSecBuffer = ^SecBuffer;
  _SecBuffer = record
    cbBuffer: Cardinal;   // Size of the buffer, in bytes
    BufferType: Cardinal; // Type of the buffer (below)
    pvBuffer: Pointer;    // Pointer to the buffer
  end;
  SecBuffer = _SecBuffer;
  PSecBufferDesc = ^SecBufferDesc;
  _SecBufferDesc = record
    ulVersion: Cardinal;  // Version number
    cBuffers: Cardinal;   // Number of buffers
    pBuffers: PSecBuffer; // Pointer to array of buffers
  end;
  SecBufferDesc = _SecBufferDesc;

  SEC_WCHAR = WCHAR;
  PSecWChar = ^TSecWChar;
  TSecWChar = SEC_WCHAR;

  PSecPkgInfoW = ^SecPkgInfoW;
  _SecPkgInfoW = record
    fCapabilities: Cardinal; // Capability bitmask
    wVersion: Word; // Version of driver
    wRPCID: Word; // ID for RPC Runtime
    cbMaxToken: Cardinal; // Size of authentication token (max)
    Name: PSecWChar; // Text name
    Comment: PSecWChar; // Comment
  end;
  SecPkgInfoW = _SecPkgInfoW;
  TSecPkgInfoW = SecPkgInfoW;

  PSecPkgInfoA = ^SecPkgInfoA;
  _SecPkgInfoA = record
    fCapabilities: Cardinal; // Capability bitmask
    wVersion: Word; // Version of driver
    wRPCID: Word; // ID for RPC Runtime
    cbMaxToken: Cardinal; // Size of authentication token (max)
    Name: PSecChar; // Text name
    Comment: PSecChar; // Comment
  end;
  SecPkgInfoA = _SecPkgInfoA;

  SEC_GET_KEY_FN = procedure (
    Arg: Pointer;                           // Argument passed in
    Principal: Pointer;                     // Principal ID
    KeyVer: Cardinal;                       // Key Version
    var Key: Pointer;                       // Returned ptr to key
    var Status: SECURITY_STATUS); stdcall;  // returned status

 _SEC_WINNT_AUTH_IDENTITY_W = record
    User: PWideChar;
    UserLength: Cardinal;
    Domain: PWideChar;
    DomainLength: Cardinal;
    Password: PWideChar;
    PasswordLength: Cardinal;
    Flags: Cardinal;
  end;
  SEC_WINNT_AUTH_IDENTITY_W = _SEC_WINNT_AUTH_IDENTITY_W;
  PSEC_WINNT_AUTH_IDENTITY_W = ^SEC_WINNT_AUTH_IDENTITY_W;
  TSecWinNTAuthIdentityW = SEC_WINNT_AUTH_IDENTITY_W;
  PSecWinNTAuthIdentityW = PSEC_WINNT_AUTH_IDENTITY_W;

  _SEC_WINNT_AUTH_IDENTITY_A = record
    User: PChar;
    UserLength: Cardinal;
    Domain: PChar;
    DomainLength: Cardinal;
    Password: PChar;
    PasswordLength: Cardinal;
    Flags: Cardinal;
  end;
  SEC_WINNT_AUTH_IDENTITY_A = _SEC_WINNT_AUTH_IDENTITY_A;
  PSEC_WINNT_AUTH_IDENTITY_A = ^SEC_WINNT_AUTH_IDENTITY_A;
  TSecWinNTAuthIdentityA = SEC_WINNT_AUTH_IDENTITY_A;
  PSecWinNTAuthIdentityA = PSEC_WINNT_AUTH_IDENTITY_A;

  PSecPkgContext_NegotiationInfoW = ^SecPkgContext_NegotiationInfoW;
  _SecPkgContext_NegotiationInfoW = record
    PackageInfo: PSecPkgInfoW;
    NegotiationState: Cardinal;
  end;
  SecPkgContext_NegotiationInfoW = _SecPkgContext_NegotiationInfoW;
  TSecPkgContextNegotiationInfoW = SecPkgContext_NegotiationInfoW;
  PSecPkgContextNegotiationInfoW = PSecPkgContext_NegotiationInfoW ;

  PSecPkgContext_NegotiationInfoA = ^SecPkgContext_NegotiationInfoA;
  _SecPkgContext_NegotiationInfoA = record
    PackageInfo: PSecPkgInfoA;
    NegotiationState: Cardinal;
  end;
  SecPkgContext_NegotiationInfoA = _SecPkgContext_NegotiationInfoA;
  TSecPkgContextNegotiationInfoA = SecPkgContext_NegotiationInfoA;
  PSecPkgContextNegotiationInfoA = PSecPkgContext_NegotiationInfoA;

  {$IFDEF UNICODE}
  PSecPkgInfo = PSecPkgInfoW;
  TSecWinNTAuthIdentity = TSecWinNTAuthIdentityW;
  PSecWinNTAuthIdentity = PSecWinNTAuthIdentityW;
  SecPkgContext_NegotiationInfo  = SecPkgContext_NegotiationInfoW;
  {$ELSE}
  PSecPkgInfo = PSecPkgInfoA;
  TSecWinNTAuthIdentity = TSecWinNTAuthIdentityA;
  PSecWinNTAuthIdentity = PSecWinNTAuthIdentityA;
  SecPkgContext_NegotiationInfo  = SecPkgContext_NegotiationInfoA;
  {$ENDIF}

  TSSPIAuthMode=(SSPIAMLogon, SSPIAMCurrentUser);
  TSSPIAuthenticationState=(SSPIASStart_0, SSPIASStart_1, SSPIASAuthenticating_0, SSPIASAuthenticating_1, SSPIASEnd_0, SSPIASEnd_1);
  TSSPIState=(SSPIUnknown, SSPIAuthentication, SSPISuccess, SSPIFailed);

  TSSPIAuthenticatingEvent = procedure (Sender: TObject; Socket: TCustomWinSocket; var Continue: bool) of object;
  TSSPIFailedNotifyEvent = procedure (Sender: TObject; Socket: TCustomWinSocket; ErrorMessage: string ; ErrorCode: integer) of object;
  TSSPISuccessNotifyEvent = procedure (Sender: TObject; Socket: TCustomWinSocket; UserName, Domain: string ; SID: PSID ; SIDLength: integer) of object;
  TServerSocketSSPI= class;

  TClientSocketSSPI = class(TCustomSocket)
  private
    FSSPISuccessNotifyEvent: TSSPISuccessNotifyEvent;
    FSSPIFailedNotifyEvent: TSSPIFailedNotifyEvent;
    FClientSocket: TClientWinSocket;
    FMode: TSSPIAuthMode;
    FDomain, FUserName, FPassword: string;
    FAuthenticationState: TSSPIAuthenticationState;
    FState: TSSPIState;
    FBufferSize: cardinal;
    InBuf, OutBuf: array[0..$7FFF] of Byte;
    CredHandle: TCredHandle;
    SecHandle: TSecHandle;
    InDesc, OutDesc: SecBufferDesc;
    InSecBuf, OutSecBuf: SecBuffer;
    {$IFDEF UNICODE}
    ServerLogonName: PSecWChar;
    {$ELSE}
    ServerLogonName: PSecChar;
    {$ENDIF}
    procedure DoAuthentication;
    procedure DoFinalizeAuthentication;
  protected
    procedure Event(Socket: TCustomWinSocket; SocketEvent: TSocketEvent); override;
    function CheckSign(const SecHandle: TSecHandle; PData: PByte; DataLen: cardinal; out PResponse: PChar; out ResponseLen: integer): boolean;
    function CreataCredentialHandle(out CredHandle: TCredHandle): boolean;
    function GetClientType: TClientType;
    procedure DoAuthSuccess(UserName, Domain: string ; SID: PSID ; SIDLength: integer);
    procedure DoAuthFailed(ErrorMessage: string ; ErrorCode: integer);
    procedure DoActivate(Value: Boolean); override;
    function GetAuthenticationProgress: bool;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Authenticate;
    property Socket: TClientWinSocket read FClientSocket;
    property ClientType: TClientType read GetClientType;
    property IsAuthenticating: bool read GetAuthenticationProgress;
  published
    property Mode: TSSPIAuthMode read FMode write FMode;
    property Domain: string read FDomain write FDomain;
    property UserName: string read FUserName write FUserName;
    property Password: string read FPassword write FPassword;
    property Active;
    property Address;
    property Host;
    property Port;
    property Service;
    property OnLookup;
    property OnConnecting;
    property OnAuthFailed: TSSPIFailedNotifyEvent read FSSPIFailedNotifyEvent write FSSPIFailedNotifyEvent;
    property OnAuthSuccess: TSSPISuccessNotifyEvent read FSSPISuccessNotifyEvent write FSSPISuccessNotifyEvent;
    property OnConnect;
    property OnDisconnect;
    property OnRead;
    property OnWrite;
    property OnError;
  end;

  TServerClientWinSocketSSPI = class(TServerClientWinSocket)
  private
    FOwner: TServerSocketSSPI;
    SecHandle: TSecHandle;
    CredHandle: TCredHandle;
    FAuthenticationState: TSSPIAuthenticationState;
    FState: TSSPIState;
    FDataWriteLen: cardinal;
    FBufferSize: cardinal;
    FBuffer: array of Byte;
    FSecSizes: SecPkgContext_Sizes;
    FSignatureSize: DWORD;
    FUserName, FDomain: string;
    FSID: PSID;
    FcbSID: cardinal;
    FSignature: array[0..255] of Byte;
    cMaxMsgSize: cardinal;
    FTag: integer;
    FIsAuthenticating: bool;
    FAbort: string;
    function SignBuffer(PData: PByte; DataLen: integer): boolean;
    procedure SendResponse(PBuf: Pointer; BufLen: cardinal);
    procedure DoFinalizeAuthentication;
  protected
    procedure Event(Socket: TCustomWinSocket; SocketEvent: TSocketEvent); override;
    procedure DoAuthentication;
    procedure DoAuthSuccess;
    procedure DoAuthFailed(ErrorMessage: string ; ErrorCode: integer);
  public
    constructor Create(AOwner: TServerSocketSSPI; Socket: TSocket; ServerWinSocket: TServerWinSocket);
    property IsAuthenticating: bool read FIsAuthenticating write FIsAuthenticating;
  end;

  TServerSocketSSPI = class(TCustomServerSocket)
  private
    FSSPIAuthenticatingEvent: TSSPIAuthenticatingEvent;
    FSSPISuccessNotifyEvent: TSSPISuccessNotifyEvent;
    FSSPIFailedNotifyEvent: TSSPIFailedNotifyEvent;
    FGuestEnabled: bool;
  protected
    procedure GetSocket(Sender: TObject; ASocket: TSocket; var ClientSocket: TServerClientWinSocket);virtual;
    function GetServerType: TServerType;
  public
    constructor Create(AOwner: TComponent); override;
    property Socket: TServerWinSocket read FServerSocket;
    property ServerType: TServerType read GetServerType;
  published
    property Active;
    property GuestEnabled: bool read FGuestEnabled write FGuestEnabled default false;
    property Port;
    property Service;
    property ThreadCacheSize default 10;
    property OnListen;
    property OnAccept;
    property OnAuthenticating: TSSPIAuthenticatingEvent read FSSPIAuthenticatingEvent write FSSPIAuthenticatingEvent;
    property OnAuthFailed: TSSPIFailedNotifyEvent read FSSPIFailedNotifyEvent write FSSPIFailedNotifyEvent;
    property OnAuthSuccess: TSSPISuccessNotifyEvent read FSSPISuccessNotifyEvent write FSSPISuccessNotifyEvent;
    property OnGetThread;
    property OnGetSocket;
    property OnThreadStart;
    property OnThreadEnd;
    property OnClientConnect;
    property OnClientDisconnect;
    property OnClientRead;
    property OnClientWrite;
    property OnClientError;
  end;

function AcceptSecurityContext(phCredential: PCredHandle; phContext: PCtxtHandle; pInput: PSecBufferDesc; fContextReq, TargetDataRep: Cardinal; phNewContext: PCtxtHandle; pOutput: PSecBufferDesc; var pfContextAttr: Cardinal; ptsExpiry: PTimeStamp): SECURITY_STATUS; stdcall; external secur32 name 'AcceptSecurityContext';
function CompleteAuthToken(phContext: PCtxtHandle; pToken: PSecBufferDesc): SECURITY_STATUS; stdcall;  external secur32 name 'CompleteAuthToken';
function ImpersonateSecurityContext(phContext: PCtxtHandle): SECURITY_STATUS; stdcall; external secur32 name 'ImpersonateSecurityContext';
function RevertSecurityContext(phContext: PCtxtHandle): SECURITY_STATUS; stdcall; external secur32 name 'RevertSecurityContext';
function MakeSignature(phContext: PCtxtHandle; fQOP: Cardinal; pMessage: PSecBufferDesc; MessageSeqNo: Cardinal): SECURITY_STATUS; stdcall; external secur32 name 'MakeSignature';
function FreeContextBuffer(pvContextBuffer: Pointer): SECURITY_STATUS; stdcall; external secur32 name 'FreeContextBuffer';
function DeleteSecurityContext(phContext: PCtxtHandle): SECURITY_STATUS; stdcall; external secur32 name 'DeleteSecurityContext';
function FreeCredentialHandle(phCredential: PCredHandle): SECURITY_STATUS; stdcall; external secur32 name 'FreeCredentialsHandle';
function VerifySignature(phContext: PCtxtHandle; pMessage: PSecBufferDesc; MessageSeqNo: Cardinal; var pfQOP: Cardinal): SECURITY_STATUS; stdcall; external secur32 name 'VerifySignature';
{$IFDEF UNICODE}
function QueryContextAttributes(phContext: PCtxtHandle; ulAttribute: Cardinal; pBuffer: Pointer): SECURITY_STATUS; stdcall; external secur32 name 'QueryContextAttributesW';
function QuerySecurityPackageInfo(pszPackageName: PSecWChar; var ppPackageInfo: PSecPkgInfoW): SECURITY_STATUS; stdcall; external secur32 name 'QuerySecurityPackageInfoW';
function AcquireCredentialsHandle(pszPrincipal, pszPackage: PSecWChar; fCredentialUse: Cardinal; pvLogonId, pAuthData: Pointer; pGetKeyFn: SEC_GET_KEY_FN; pvGetKeyArgument: Pointer; phCredential: PCredHandle; var ptsExpiry: TTimeStamp): SECURITY_STATUS; stdcall; external secur32 name 'AcquireCredentialsHandleW';
function InitializeSecurityContext(phCredential: PCredHandle; phContext: PCtxtHandle; pszTargetName: PSecWChar; fContextReq, Reserved1, TargetDataRep: Cardinal; pInput: PSecBufferDesc; Reserved2: Cardinal; phNewContext: PCtxtHandle; pOutput: PSecBufferDesc; var pfContextAttr: Cardinal; ptsExpiry: PTimeStamp): SECURITY_STATUS; stdcall; external secur32 name 'InitializeSecurityContextW';
{$ELSE}
function QueryContextAttributes(phContext: PCtxtHandle; ulAttribute: Cardinal; pBuffer: Pointer): SECURITY_STATUS; stdcall; external secur32 name 'QueryContextAttributesA';
function QuerySecurityPackageInfo(pszPackageName: PSecChar; var ppPackageInfo: PSecPkgInfoA): SECURITY_STATUS; stdcall; external secur32 name 'QuerySecurityPackageInfoA';
function AcquireCredentialsHandle(pszPrincipal, pszPackage: PSecChar; fCredentialUse: Cardinal; pvLogonId, pAuthData: Pointer; pGetKeyFn: SEC_GET_KEY_FN; pvGetKeyArgument: Pointer; phCredential: PCredHandle; var ptsExpiry: TTimeStamp): SECURITY_STATUS; stdcall; external secur32 name 'AcquireCredentialsHandleA';
function InitializeSecurityContext(phCredential: PCredHandle; phContext: PCtxtHandle; pszTargetName: PSecChar; fContextReq, Reserved1, TargetDataRep: Cardinal; pInput: PSecBufferDesc; Reserved2: Cardinal; phNewContext: PCtxtHandle; pOutput: PSecBufferDesc; var pfContextAttr: Cardinal; ptsExpiry: PTimeStamp): SECURITY_STATUS; stdcall; external secur32 name 'InitializeSecurityContextA';
{$ENDIF}

resourcestring
        S_SSPI_ACQUIRECREDENTIALSHANDLE_FAILED='AcquireCredentialsHandle failed';
        S_SSPI_QUERYSECURITYPACKAGEINFO_FAILED='QuerySecurityPackageInfo failed';
        S_SSPI_QUERYCONTEXTATTRIBUTES_FAILED='QueryContextAttributes failed';
        S_SSPI_SIGNATURE_FAILED='Signature failed';
        S_SSPI_SENDING_FAILED='Sending failed';
        S_SSPI_INBOUND_TOO_LONG='Inbound message too long';
        S_SSPI_ACCESS_DENIED='Access denied';
        S_SSPI_CONTEXT_SECURITY_FAILED='InitializeSecurityContext failed';
        S_SSPI_COMPLETEAUTHTOKEN_FAILED='CompleteAuthToken failed';
        S_SSPI_CREDENTIAL_ERROR='Credential creation error';
        S_SSPI_AUTHENTICATION_FAILED='Authentication failed';
        S_SSPI_IMPERSONATION_FAILED='Impersonation failed';
        S_SSPI_ABORT='Abort';

procedure Register;

implementation

const AuthenticationTAG='AUTH'#13#10;

function GetUserNameExString: string;
const NameDisplay            = 3;
      NameDnsDomain          = 12;
var BufSize: DWORD;
    Buf: PWideChar;
    GetUserNameEx: function (NameFormat: DWORD; lpNameBuffer: LPWSTR; var nSize: ULONG): BOOL; stdcall;
begin
     Result := '';
     Buf:=GetMemory(1024);
     BufSize := SizeOf(Buf) div SizeOf(Buf[0]);
     GetUserNameEx := GetProcAddress(GetModuleHandle('secur32.dll'), 'GetUserNameExW');
     if Assigned(GetUserNameEx) then
     begin
          if GetUserNameEx(NameDnsDomain, Buf, BufSize) then Result := Buf;
          if Result='' then if GetUserNameEx(NameDisplay, Buf, BufSize) then Result := Buf else else Result:='';
     end;
     FreeMem(Buf);
end;

{ TClientSocketSSPI }

constructor TClientSocketSSPI.Create(AOwner: TComponent);
begin
     inherited Create(AOwner);
     FClientSocket := TClientWinSocket.Create(INVALID_SOCKET);
     InitSocket(FClientSocket);
     FMode:=SSPIAMLogon;
     FState:=SSPIUnknown;
     FClientSocket.ClientType:=ctNonBlocking;
end;

destructor TClientSocketSSPI.Destroy;
begin FClientSocket.Free; inherited Destroy; end;

function TClientSocketSSPI.GetClientType: TClientType;
begin Result := FClientSocket.ClientType; end;

procedure TClientSocketSSPI.DoActivate(Value: Boolean);
begin
     if (Value <> FClientSocket.Connected) and not (csDesigning in ComponentState) then
     begin
          FState:=SSPIUnknown;
          if FClientSocket.Connected then FClientSocket.Disconnect(FClientSocket.SocketHandle) else FClientSocket.Open(Host, Address, Service, Port, ClientType = ctBlocking);
     end;
end;

function TClientSocketSSPI.GetAuthenticationProgress: bool;
begin Result:=FState=SSPIAuthentication; end;

procedure TClientSocketSSPI.DoAuthFailed(ErrorMessage: string ; ErrorCode: integer);
begin
     if FState=SSPIAuthentication then
     begin
          FState:=SSPIFailed;
          if Assigned(FSSPIFailedNotifyEvent) then FSSPIFailedNotifyEvent(Self, FClientSocket, ErrorMessage, ErrorCode);
          DoFinalizeAuthentication;
     end;
end;

procedure TClientSocketSSPI.DoAuthSuccess(UserName, Domain: string ; SID: PSID ; SIDLength: integer);
begin
     if FState=SSPIAuthentication then
     begin
          FState:=SSPISuccess;
          if Assigned(FSSPISuccessNotifyEvent) then FSSPISuccessNotifyEvent(Self, FClientSocket, UserName, Domain, SID, SIDLength);
          DoFinalizeAuthentication;
     end;
end;

procedure TClientSocketSSPI.Event(Socket: TCustomWinSocket; SocketEvent: TSocketEvent);
begin
     case SocketEvent of
     seRead: if FState=SSPIAuthentication then DoAuthentication else inherited;
     seDisconnect: begin if FState=SSPIAuthentication then DoFinalizeAuthentication; inherited; end;
     else inherited;
     end;
end;

// Vrification du message reu
function TClientSocketSSPI.CheckSign(const SecHandle: TSecHandle; PData: PByte; DataLen: cardinal; out PResponse: PChar; out ResponseLen: integer): boolean;
var Desc: SecBufferDesc;
    SecBuf: array[0..1] of SecBuffer;
    QOP: Cardinal;
    SS: SECURITY_STATUS;
begin
     with Desc do begin ulVersion:= SECBUFFER_VERSION; cBuffers:= 2; pBuffers:= @SecBuf; end;
     with SecBuf[0] do begin cbBuffer:= PDWORD(PData)^; BufferType:= SECBUFFER_TOKEN; pvBuffer:= Pointer(Cardinal(PData) + SizeOf(DWORD)); end;
     PResponse:= Pointer(Cardinal(PData) + SecBuf[0].cbBuffer + SizeOf(DWORD));
     ResponseLen:= DataLen - SecBuf[0].cbBuffer - SizeOf(DWORD);
     with SecBuf[1] do begin cbBuffer:= ResponseLen; BufferType:= SECBUFFER_DATA; pvBuffer:= PResponse; end;
     QOP:= 0; SS:= VerifySignature(@SecHandle, @desc, 0, QOP); Result:= Succeeded(SS);
end;

// Cration d'un Handle d'authentification  transmettre au serveur
function TClientSocketSSPI.CreataCredentialHandle(out CredHandle: TCredHandle): boolean;
var ss: SECURITY_STATUS;
    Expiry: TimeStamp;
    AuthIdent: TSecWinNTAuthIdentity;
    PAuthident: PSecWinNTAuthIdentity;

    wDomain: array[0..CRED_MAX_DOMAIN_TARGET_NAME_LENGTH] of {$IFDEF UNICODE}WChar{$ELSE}Char{$ENDIF};
    wUserName: array[0..CRED_MAX_USERNAME_LENGTH] of {$IFDEF UNICODE}WChar{$ELSE}Char{$ENDIF};
    wPassword: array[0..127] of {$IFDEF UNICODE}WChar{$ELSE}Char{$ENDIF};
    i: integer;
begin
     if FMode=SSPIAMLogon then
     begin
          FillChar(wDomain, SizeOf(wDomain), #0);
          FillChar(wUserName, SizeOf(wUserName), #0);
          FillChar(wPassword, SizeOf(wPassword), #0);
          for i:=0 to Min(SizeOf(wDomain), length(Domain))-1 do wDomain[i]:=Domain[i+1];
          for i:=0 to Min(SizeOf(wUserName), length(UserName))-1 do wUserName[i]:=UserName[i+1];
          for i:=0 to Min(SizeOf(wPassword), length(Password))-1 do wPassword[i]:=Password[i+1];
          with AuthIdent do
          begin
               User:= @wUserName;
               UserLength:= StrLen(AuthIdent.User);
               Password:= @wPassword;
               PasswordLength:= StrLen(AuthIdent.Password);
               Domain:= @wDomain;
               DomainLength:= StrLen(AuthIdent.Domain);
               Flags:={$IFDEF UNICODE}SEC_WINNT_AUTH_IDENTITY_UNICODE{$ELSE}SEC_WINNT_AUTH_IDENTITY_ANSI{$ENDIF};
          end;
          PAuthIdent:= @AuthIdent;
      end else PAuthident:= nil;
      SetLastError(0);
      SS:= AcquireCredentialsHandle(nil, @sPackageName[1], SECPKG_CRED_OUTBOUND, nil, PAuthIdent, nil, nil, @CredHandle, Expiry);
      FillChar(wPassword, SizeOf(wPassword), 0);
      Result:= Succeeded(SS);
end;

// Procdure d'authentification (appele plusieurs fois lors des changes avec le serveur)
procedure TClientSocketSSPI.DoAuthentication;
var PInDesc: PSecBufferDesc;
    Attrib: ULONG;
    SS: SECURITY_STATUS;
    NegInfo: SecPkgContext_NegotiationInfo;
    PSH: PCtxtHandle;
    Expiry: TimeStamp;
    Reponse: PChar;
    Reponselength, SIDSize: integer;
    Buf: array[0..5] of Ansichar;
    WBuf: array of byte;
    User, Domain: string;
    SID: PSID;
begin
     if FAuthenticationState in [SSPIASAuthenticating_0, SSPIASEnd_0] then
     begin
          // Rception de la taille du buffer  lire
          if FClientSocket.ReceiveLength>=SizeOf(FBufferSize) then
          begin
               FClientSocket.ReceiveBuf(FBufferSize, SizeOf(FBufferSize));
               if FBufferSize > SizeOf(InBuf) then begin DoAuthFailed(S_SSPI_INBOUND_TOO_LONG, FBufferSize); exit; end
               else
               begin
                    if FBufferSize = 0 then begin DoAuthFailed(S_SSPI_ACCESS_DENIED, 0); exit; end;
                    if FAuthenticationState=SSPIASAuthenticating_0 then FAuthenticationState:=SSPIASAuthenticating_1 else FAuthenticationState:=SSPIASEnd_1;
               end;
          end
          else
          exit; {Attente d'une rponse du serveur}
     end;

     if FAuthenticationState=SSPIASAuthenticating_1 then
        // Rception du buffer dont on connat la taille (durant le processus d'authentification)
        if Cardinal(FClientSocket.ReceiveLength)>=FBufferSize then FClientSocket.ReceiveBuf(InBuf, FBufferSize) else exit;

     if FAuthenticationState=SSPIASEnd_1 then
     begin
          // Rception du buffer dont on connat la taille (fin du processus d'authentification)
          if Cardinal(FClientSocket.ReceiveLength)>=FBufferSize then
          begin
               FClientSocket.ReceiveBuf(InBuf, FBufferSize);
               if CheckSign(SecHandle, @InBuf, FBufferSize, Reponse, ReponseLength) then
               begin
                    User:=String(Reponse);
                    Reponse:=Reponse+length(User)+1;
                    Domain:=String(Reponse);
                    Reponse:=Reponse+length(Domain)+1;
                    SIDSize:=ReponseLength-(length(User)+1)*SizeOf(User[1])-(length(Domain)+1)*SizeOf(Domain[1]);
                    SID:=GetMemory(SIDSize);
                    CopyMemory(SID, Reponse, SIDSize);
                    DoAuthSuccess(User, Domain, SID, SIDSize);
                    FreeMem(SID);
               end else DoAuthFailed(S_SSPI_SIGNATURE_FAILED, WSAGetLastError);
               if FClientSocket.ReceiveLength>0 then Event(FClientSocket, seRead); {Poursuite de la lecture de la rponse du serveur}
          end;
          exit; {Attente d'une rponse du serveur}
     end;

     // Arriv ici, FState = SSPIAuthentication et FAuthenticationState=SSPIASStart ou SSPIASAuthenticating_1
     try
        with OutDesc do begin ulVersion:= SECBUFFER_VERSION; cBuffers:= 1; pBuffers:= @OutSecBuf; end;
        with OutSecBuf do begin cbBuffer:= SizeOf(OutBuf); BufferType:= SECBUFFER_TOKEN; pvBuffer:= @OutBuf; end;
        if FAuthenticationState=SSPIASStart_0 then begin PSH:= nil; PInDesc:= nil; end else
        begin
             with InDesc do begin ulVersion:= SECBUFFER_VERSION; cBuffers:= 1; pBuffers:= @InSecBuf; end;
             with InSecBuf do begin cbBuffer:= FBufferSize; BufferType:= SECBUFFER_TOKEN; pvBuffer:= @InBuf; end;
             PSH:= @SecHandle;
             PInDesc:= @InDesc;
        end;
        SS:= InitializeSecurityContext(@CredHandle, PSH, ServerLogonName, ISC_REQ_INTEGRITY, 0, SECURITY_NATIVE_DREP, PInDesc, 0, @SecHandle, @OutDesc, Attrib, @Expiry);
        if Failed(SS) then begin DoAuthFailed(S_SSPI_CONTEXT_SECURITY_FAILED, SS); exit; end;
        if (SEC_I_COMPLETE_NEEDED = SS) or (SEC_I_COMPLETE_AND_CONTINUE = SS) then
        begin
             SS:= CompleteAuthToken(@SecHandle, @OutDesc);
             if Failed(SS) then begin DoAuthFailed(S_SSPI_COMPLETEAUTHTOKEN_FAILED, SS); exit; end;
        end;
        if OutSecBuf.cbBuffer <> 0 then
        begin
             if FAuthenticationState=SSPIASStart_0 then
             begin
                  Buf:=AuthenticationTAG;
                  send(FClientSocket.SocketHandle, Buf, length(Buf), 0);
             end;
             Setlength(WBuf, SizeOf(DWORD)+OutSecBuf.cbBuffer);
             try
                CopyMemory(@WBuf[0], @OutSecBuf.cbBuffer, SizeOf(DWORD));
                CopyMemory(@WBuf[SizeOf(DWORD)], OutSecBuf.pvBuffer, OutSecBuf.cbBuffer);
                SetLastError(0);
                if Send(FClientSocket.SocketHandle, WBuf[0], length(WBuf), 0)<>length(WBuf) then begin DoAuthFailed(S_SSPI_SENDING_FAILED, GetLastError); exit; end;
             finally
                Finalize(WBuf);
             end;
        end;
        if SEC_E_OK = SS then
        begin
            SS:= QueryContextAttributes(@SecHandle, SECPKG_ATTR_NEGOTIATION_INFO, @NegInfo);
            if Succeeded(SS) then FAuthenticationState:=SSPIASEnd_0;
            FreeContextBuffer(NegInfo.PackageInfo);
        end
        else
        FAuthenticationState:=SSPIASAuthenticating_0;
     finally
        if FClientSocket.ReceiveLength>0 then Event(FClientSocket, seRead); {Poursuite de la lecture de la rponse du serveur}
     end;
end;

// Lancement de l'authentification
procedure TClientSocketSSPI.Authenticate;
begin
     if (FClientSocket.Connected) and (FState<>SSPIAuthentication) then
     begin
          FState:=SSPIAuthentication;
          FillChar(SecHandle, SizeOf(SecHandle), 0);
          if CreataCredentialHandle(CredHandle) then
          begin
               FState:=SSPIAuthentication;
               if (FMode=SSPIAMCurrentUser) and (GetUserNameExString<>'') then ServerLogonName:=@GetUserNameExString[1] else ServerLogonName:=nil;
               FAuthenticationState:=SSPIASStart_0;
               DoAuthentication;
          end else DoAuthFailed(S_SSPI_CREDENTIAL_ERROR, GetLastError);
     end;
end;

// Fin de l'authentification
procedure TClientSocketSSPI.DoFinalizeAuthentication;
begin
     FState:=SSPIUnknown;
     if (SecHandle.dwLower or SecHandle.dwUpper) <> 0 then DeleteSecurityContext(@SecHandle);
     if (CredHandle.dwLower or CredHandle.dwUpper) <> 0 then FreeCredentialHandle(@CredHandle);
end;

{ TServerSocketSSPI }

constructor TServerSocketSSPI.Create(AOwner: TComponent);
begin
     inherited Create(AOwner);
     FServerSocket := TServerWinSocket.Create(INVALID_SOCKET);
     InitSocket(FServerSocket);
     FServerSocket.ThreadCacheSize := 10;
     FServerSocket.ServerType:=stNonBlocking;
     OnGetSocket:=GetSocket;
end;

function TServerSocketSSPI.GetServerType: TServerType;
begin Result := FServerSocket.ServerType; end;

procedure TServerSocketSSPI.GetSocket(Sender: TObject; ASocket: TSocket; var ClientSocket: TServerClientWinSocket);
begin ClientSocket:=TServerClientWinSocketSSPI.Create(self, ASocket, FServerSocket); end;

{ TServerClientWinSocketSSPI }

// Envoi de la rponse signe
procedure TServerClientWinSocketSSPI.SendResponse(PBuf: Pointer; BufLen: cardinal);
var WBuf: array of byte;
begin
     if SignBuffer(PBuf, BufLen) then
     begin
          Setlength(WBuf, 2*SizeOf(Cardinal)+FSignatureSize+Buflen);
          FDataWritelen:=SizeOf(Cardinal)+FSignatureSize+Buflen;
          try
             CopyMemory(@WBuf[0], @FDataWritelen, SizeOf(Cardinal));
             CopyMemory(@WBuf[SizeOf(Cardinal)], @FSignatureSize, SizeOf(Cardinal));
             CopyMemory(@WBuf[2*SizeOf(Cardinal)], @FSignature[0], FSignatureSize);
             CopyMemory(@WBuf[2*SizeOf(Cardinal)+FSignatureSize], PBuf, BufLen);
             SetLastError(0);
             if Send(SocketHandle, WBuf[0], length(WBuf), 0)<>length(WBuf) then DoAuthFailed(S_SSPI_SENDING_FAILED, GetLastError);
          finally
             Finalize(WBuf);
          end;
     end else DoAuthFailed(S_SSPI_SIGNATURE_FAILED, GetLastError);
end;

// Signature du buffer avant l'envoi
function TServerClientWinSocketSSPI.SignBuffer(PData: PByte; DataLen: integer): boolean;
var Desc: SecBufferDesc;
    SecBuf: array[0..2] of SecBuffer;
    SS: SECURITY_STATUS;
begin
     SetLastError(0);
     with Desc do begin ulVersion:= SECBUFFER_VERSION; cBuffers:= 3; pBuffers:= @SecBuf; end;
     with SecBuf[0] do begin cbBuffer:= FSecSizes.cbMaxSignature; BufferType:= SECBUFFER_TOKEN; pvBuffer:= @FSignature; end;
     with SecBuf[1] do begin cbBuffer:= DataLen; BufferType:= SECBUFFER_DATA; pvBuffer:= PData; end;
     with SecBuf[2] do begin cbBuffer:= 0; BufferType:= SECBUFFER_PADDING; pvBuffer:= nil; end;
     SS:= MakeSignature(@SecHandle, 0, @Desc, 0);
     Result:= Succeeded(SS); if Result then FSignatureSize:= SecBuf[0].cbBuffer;
end;

// Socket Serveur->Client
constructor TServerClientWinSocketSSPI.Create(AOwner: TServerSocketSSPI; Socket: TSocket; ServerWinSocket: TServerWinSocket);
begin
     CredHandle.dwLower:=0;
     CredHandle.dwUpper:=0;
     FIsAuthenticating:=false;
     FOwner:=AOwner;
     inherited Create(Socket, ServerWinSocket);
end;

procedure TServerClientWinSocketSSPI.Event(Socket: TCustomWinSocket; SocketEvent: TSocketEvent);
var Buf: array[0..5] of Ansichar;
    pPkgInfo: PSecPkgInfo;
    Expiry: TimeStamp;
    SS: SECURITY_STATUS;
    Continue: bool;
begin
     case SocketEvent of
     seRead:
     begin
          if FIsAuthenticating then DoAuthentication
          else
          if (FTag>0) and (FTag=Socket.ReceiveLength) then begin FTag:=0; inherited; end
          else
          begin
               FTag:=Socket.ReceiveLength;
               if (recv(Socket.SocketHandle, Buf, length(AuthenticationTAG), MSG_PEEK)=length(AuthenticationTAG)) and (Buf=AuthenticationTAG) then
               begin
                    recv(Socket.SocketHandle, Buf, length(AuthenticationTAG), 0);
                    FIsAuthenticating:=false;
                    FAbort:='';
                    Continue:=true;
                    FSID:=nil;
                    if Assigned(FOwner.FSSPIAuthenticatingEvent) then FOwner.FSSPIAuthenticatingEvent(Self, Self, Continue);
                    if Continue then
                    begin
                         SetLastError(0);
                         SS:= QuerySecurityPackageInfo(@sPackageName[1], pPkgInfo);
                         if Succeeded(SS) then
                         begin
                              cMaxMsgSize:= pPkgInfo.cbMaxToken;
                              SS:=AcquireCredentialsHandle(nil, @sPackageName[1], SECPKG_CRED_INBOUND, nil, nil, nil, nil, @CredHandle, Expiry);
                              if Failed(SS) then FAbort:=S_SSPI_ACQUIRECREDENTIALSHANDLE_FAILED;
                         end
                         else FAbort:=S_SSPI_QUERYSECURITYPACKAGEINFO_FAILED;
                         FreeContextBuffer(pPkgInfo);
                    end
                    else FAbort:=S_SSPI_ABORT;
                    FAuthenticationState:=SSPIASStart_0;
                    FState:=SSPIAuthentication;
                    FIsAuthenticating:=true;
                    DoAuthentication;
               end
               else
               inherited;
          end;
     end;
     seDisconnect: begin if FIsAuthenticating then DoFinalizeAuthentication; inherited; end;
     seConnect: begin FState:=SSPIUnknown; FIsAuthenticating:=false; FTag:=0; inherited; end;
     else inherited;
     end;
end;

procedure TServerClientWinSocketSSPI.DoAuthSuccess;
var WBuf: array of byte;
begin
     if FState=SSPIAuthentication then
     begin
          Setlength(WBuf, (length(FUserName)+1)*SizeOf(FUserName[1])+(length(FDomain)+1)*SizeOf(FDomain[1])+byte(FcbSid));
          ZeroMemory(WBuf, length(WBuf));
          CopyMemory(@WBuf[0], PChar(FUserName), length(FUserName)*SizeOf(FUserName[1]));
          CopyMemory(@WBuf[(length(FUserName)+1)*SizeOf(FUserName[1])], PChar(FDomain), length(FDomain)*SizeOf(FDomain[1]));
          CopyMemory(@WBuf[(length(FUserName)+1)*SizeOf(FUserName[1])+(length(FDomain)+1)*SizeOf(FDomain[1])], FSID, FcbSid);
          SendResponse(WBuf, length(WBuf));
          Finalize(WBuf);
          if FState<>SSPIFailed then
          begin
               FState:=SSPISuccess;
               if Assigned(FOwner.FSSPISuccessNotifyEvent) then FOwner.FSSPISuccessNotifyEvent(Self, Self, string(FUserName), string(FDomain), FSID, FcbSid);
               DoFinalizeAuthentication;
          end;
     end;
end;

procedure TServerClientWinSocketSSPI.DoAuthFailed(ErrorMessage: string ; ErrorCode: integer);
var B: cardinal;
begin
     if FState=SSPIAuthentication then
     begin
          FState:=SSPIFailed;
          if (ErrorMessage=S_SSPI_AUTHENTICATION_FAILED) or (ErrorMessage=S_SSPI_QUERYCONTEXTATTRIBUTES_FAILED) or (ErrorMessage=S_SSPI_IMPERSONATION_FAILED) or (FAbort<>'') then begin B:=0; Send(SocketHandle, B, SizeOf(B), 0); end;
          if (ErrorMessage<>S_SSPI_ABORT) and Assigned(FOwner.FSSPIFailedNotifyEvent) then FOwner.FSSPIFailedNotifyEvent(Self, Self, ErrorMessage, ErrorCode);
          DoFinalizeAuthentication;
     end;
end;

procedure TServerClientWinSocketSSPI.DoFinalizeAuthentication;
begin
     Finalize(FBuffer);
     if Assigned(FSID) then begin FreeMem(FSID); FSID:=nil; end;
     FIsAuthenticating:=false;
     FTag:=0;          
     if (SecHandle.dwLower or SecHandle.dwUpper) <> 0 then DeleteSecurityContext(@SecHandle);
     if (CredHandle.dwLower or CredHandle.dwUpper) <> 0 then FreeCredentialHandle(@CredHandle);
end;

procedure TServerClientWinSocketSSPI.DoAuthentication;
var WBuf: array of byte;
    snu: SID_NAME_USE;
    SS: SECURITY_STATUS;
    Expiry: TimeStamp;
    OutDesc, InDesc: SecBufferDesc;
    OutBuf, InBuf: SecBuffer;
    OutB: PChar;
    Attribs: ULONG;
    NameLen, DomainSize: Cardinal;
begin
     if FAuthenticationState in [SSPIASStart_0, SSPIASAuthenticating_0] then
     begin
          // Rception de la taille du buffer  lire
          if ReceiveLength>=SizeOf(FBufferSize) then
          begin
               ReceiveBuf(FBufferSize, SizeOf(FBufferSize));
               if FBufferSize > $7FFF then begin DoAuthFailed(S_SSPI_INBOUND_TOO_LONG, FBufferSize); exit; end
               else
               begin
                    if FAuthenticationState=SSPIASStart_0 then FAuthenticationState:=SSPIASStart_1 else FAuthenticationState:=SSPIASAuthenticating_1;
                    Setlength(FBuffer, FBufferSize);
               end;
          end
          else
          exit; {Attente des donnes du client}
     end;

     if FAuthenticationState in [SSPIASStart_1, SSPIASAuthenticating_1] then
        // Rception du buffer dont on connat la taille (durant le processus d'authentification)
        if Cardinal(ReceiveLength)>=FBufferSize then ReceiveBuf(FBuffer[0], FBufferSize) else exit;


     if FAbort<>'' then begin DoAuthFailed(FAbort, GetLastError); exit; end;

     with OutDesc do begin ulVersion:= SECBUFFER_VERSION; cBuffers:= 1; pBuffers:= @OutBuf; end;
     with OutBuf do begin cbBuffer:= cMaxMsgSize; OutB:=GetMemory(cMaxMsgSize); BufferType:= SECBUFFER_TOKEN; pvBuffer:=OutB; end;
     with InDesc do begin ulVersion:= SECBUFFER_VERSION; cBuffers:= 1; pBuffers:= @InBuf; end;
     with InBuf do begin cbBuffer:= FBufferSize; BufferType:= SECBUFFER_TOKEN; pvBuffer:= FBuffer; end;

     try
        Attribs:= 0;
        if FAuthenticationState=SSPIASStart_1 then
        begin
             SS:= AcceptSecurityContext(@CredHandle, nil, @InDesc, Attribs, SECURITY_NATIVE_DREP, @SecHandle, @OutDesc, Attribs, @Expiry);
             FAuthenticationState:=SSPIASAuthenticating_0;
        end
        else SS:= AcceptSecurityContext(@CredHandle, @SecHandle, @InDesc, Attribs, SECURITY_NATIVE_DREP, @SecHandle, @OutDesc, Attribs, @Expiry);
        if Failed(SS) then begin DoAuthFailed(S_SSPI_AUTHENTICATION_FAILED, GetLastError); exit; end;

        if (SS = SEC_I_COMPLETE_NEEDED) or (SS = SEC_I_COMPLETE_AND_CONTINUE) then
        begin
             SS:= CompleteAuthToken(@SecHandle, @OutDesc);
             if Failed(SS) then begin DoAuthFailed(S_SSPI_AUTHENTICATION_FAILED, GetLastError); exit; end;
        end;
        if SS = SEC_E_OK then
        begin
             SS:= QueryContextAttributes(@SecHandle, SECPKG_ATTR_SIZES, @FSecSizes);
             if Failed(SS) then begin DoAuthFailed(S_SSPI_QUERYCONTEXTATTRIBUTES_FAILED, GetLastError); exit; end;
             if Succeeded(ImpersonateSecurityContext(@SecHandle)) then
             try
                NameLen:= SizeOf(FSignature);
                if GetUserName(@FSignature[0], NameLen) then SetString(FUserName, PChar(@FSignature[0]), NameLen - 1);
                DomainSize := 0;
                FcbSid:=0;
                LookupAccountName(nil, PChar(FUserName), nil, FcbSid, nil, DomainSize, snu);
                if (FcbSid=0) and not FOwner.GuestEnabled then FAuthenticationState:=SSPIASEnd_1 else
                begin
                     FSID:=GetMemory(FcbSid);
                     FDomain:=StringOfChar(#0, DomainSize);
                     LookupAccountName(nil, PChar(FUserName), FSID, FcbSid, @FDomain[1], DomainSize, snu);
                     FDomain:=Trim(FDomain);
                     FAuthenticationState:= SSPIASEnd_0;
                end;
             finally
                RevertSecurityContext(@SecHandle);
             end
             else FAuthenticationState:=SSPIASEnd_1;
        end;

        if OutBuf.cbBuffer <> 0 then
        begin
             Setlength(WBuf, SizeOf(Cardinal)+OutBuf.cbBuffer);
             try
                CopyMemory(@WBuf[0], @OutBuf.cbBuffer, SizeOf(Cardinal));
                CopyMemory(@WBuf[SizeOf(Cardinal)], OutBuf.pvBuffer, OutBuf.cbBuffer);
                SetLastError(0);
                if Send(SocketHandle, WBuf[0], length(WBuf), 0)<>length(WBuf) then begin DoAuthFailed(S_SSPI_SENDING_FAILED, GetLastError); exit; end;
             finally
                Finalize(WBuf);
             end;
        end;
     finally
       FreeMemory(OutB);
     end;

     if FAuthenticationState=SSPIASend_0 then DoAuthSuccess else
     if FAuthenticationState=SSPIASend_1 then DoAuthFailed(S_SSPI_IMPERSONATION_FAILED, GetLastError);
end;

procedure Register;
begin
      RegisterComponents('SSPI', [TClientSocketSSPI, TServerSocketSSPI]);
end;

end.
